import java.util.*;

/** Klasse zur Datumsverwaltung
  *
  * @author Bernhard Fiser 0109815
  * @version 1.0
  */

public class myDate
{
	/* Public Variablen fr Tag, Monat und Jahr */
	int	day,
		mon,
		year;
	/* Public Variable fr den Konvertierungsmodus,
	 * d. h. in welchem Format war der String vor der Konvertierung
	 * conv_mode = 0 : String war numerisch
	 * conv_mode = 1 : String war alphanumerisch
	 */
	int	conv_mode;

	/* StringTokenizervariable fr das Stringparsing */
	private StringTokenizer	st;
	/* Tokencounter */
	private int		tcount,
	/* temporre Variablen fr Tag/Jahr und Jahr/tag */
				v0,
				v1,
	/* Laufvariable */
				i;
	/* temporre Stringvariable */
	private String		v;
	/* Arrays die die Monatsnamen beinhalten */
	private	String[]	mons = {"Jan", "Feb", "Mar", "Apr", "Mai", "Jun", "Jul", "Aug", "Sep", "Okt", "Nov", "Dez"};
	private	String[]	mone = {"Jnner", "Februar", "Mrz", "April", "Mai", "Juni", "Juli", "August", "September", "Oktober", "November", "Dezember"};
	/* Arrays, die die gltigen maximalen Tagesnummern beinhalten */
	private int[]		mdays = {31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31};


	/** Erstellen eines myDate-Objects */
	public myDate()
	{
		this.day = 0;
		this.mon = 0;
		this.year = 0;
		this.conv_mode = 0;
	}

	/** Parsed einen String in Tag, Monat und Jahr
	  *
	  * @param String date_str
	  */
	public boolean parseString(String date_str)
	{
		/* StringTokenizer initialisieren */
		st = new StringTokenizer(date_str, "/-. ");

		/* Tokencounter initialisieren */
		tcount = 0;
		/* Jeden einzelnen Token des Strings parsen */
		while (st.hasMoreTokens())
		{
			/* Falls String mehr als 3 Tokens hat Fehler zurckgeben */
			if (tcount > 3)
				return false;

			/* Token lesen */
			v = st.nextToken();

			/* Token konvertieren, abhngig von Position des Tokens (tcount) */
			switch (tcount)
			{
				case 0 :
					/* String in int umwandeln, und exception
					 * abfangen, falls String keine Zahl enthlt */
					try
					{
						v0 = Integer.parseInt(v);
					}
					catch (NumberFormatException e)
					{
						return false;
					}
					break;
				case 1 :
					/* Mittleren Token (tcount == 1) mit Monatsnamen vergleichen */
					for (i = 0; i < 12; i++)
					{
						if ((v.compareTo(mons[i]) == 0) || (v.compareTo(mone[i]) == 0))
						{
							/* Falls Monatsname gefunden, Variable mon auf gefundene
							 * Monatsnummer setzen, und Konvertierungsmodus (conv_mode)
							 * setzen. */
							this.mon = i + 1;
							this.conv_mode = 1;
							break;
						}
					}

					/* Falls kein Monat gefunden (conv_mode == 0)
					 * String in int konvertieren und exception abfangen */
					try
					{
						if (this.conv_mode == 0)
							this.mon = Integer.parseInt(v);
					}
					catch (NumberFormatException e)
					{
						return false;
					}
					break;
				case 2 :
					/* String in int umwandeln, und exception
					 * abfangen, falls String keine Zahl enthlt */
					try
					{
						v1 = Integer.parseInt(v);
					}
					catch (NumberFormatException e)
					{
						return(false);
					}
					break;
				default :
					return false;
			}
			/* Tokencounter tcount erhhen */
			tcount++;
		}

		/* Falls String weniger als 3 Tokens hat,
		 * Fehler zurckgeben */
		if (tcount < 3)
			return false;

		/* Falls Konvertierunsmodus alphanumerisch, dann
		 * Variablen setzen, zuerst Tag, dann Jahr */
		if (this.conv_mode == 1)
		{
			this.day = v0;
			this.year = v1;
		}
		/* andernfalls in umgekehrter Reihenfolge,
		 * zuerst Jahr, dann Tag */
		else
		{
			this.day = v1;
			this.year = v0;
		}

		/* Korrektur der Jahreswerte,
		 * alles was kleiner als 40 (Annahme) ist nach dem
		 * Jahr 2000 */
		if (this.year < 40)
			this.year += 2000;
		/* Korrektur der Jahreswerte,
		 * alles was kleiner als 100 und grer als 39 (Annahme) ist vor dem
		 * Jahr 2000 */
		if (this.year < 100)
			this.year += 1900;

		/* Konvertierung war erfolgreich */
		return true;
	}

	/** berprft ob bergebenes Datum gltig ist
	  *
	  * @return true wenn gltig, false wenn ungltig
	  */
	public boolean check_date()
	{
		/* Jedes 4te Jahr die Tageszahl des Februars
		 * anpassen (um eins erhhen) */
		if (this.year % 4 == 0)
			mdays[1]++;

		/* Falls die Tagesnummer im entsprechenden Monat grer
		 * als die erlaubte Zahl, dann Fehler zurckgeben,
		 * d. h. Datum ungltig. */
		if (this.day > mdays[this.mon - 1])
			return false;

		/* berprfung war positiv */
		return true;
	}

	/** Gibt Datum numerisch auf stdout aus */
	public void printn()
	{
		System.out.print(this.day + "/" + this.mon + "/" + this.year);
	}

	/** Gibt Datum alphanumerisch auf stdout aus */
	public void printa()
	{
		System.out.print(this.day + ". " + mone[this.mon - 1] + " " + this.year);
	}
}
